<?php

use Illuminate\Database\Capsule\Manager as Capsule;
class Cloudns_Database {
	
	protected $version;
	
	public function __construct ($params) {
		$this->version = $params['shortVersion'];
	}
	
	public function select ($table, $tbl_params=array(), $order='name') {
		$response = array();
		if ($this->version >= 6) {			
			$query = Capsule::table($table);
			foreach ($tbl_params as $column=>$value) {
				$query->where($column, $value);
			}
			
			$query->orderBy($order, 'ASC');
			
			$rows = $query->get();
			foreach ($rows as $row) {
				if ($table == 'tbldomains') {
					$response[] = array(
						'name' => $row->domain,
						'serviceid' => '',
					);
				} else {
					$response[] = array(
						'name' => $row->name,
						'serviceid' => $row->serviceid,
					);
				}
			}
		// versions below 6 use currently depricated query builders
		} else {
			
			$where = array();
			foreach ($tbl_params as $param=>$value) {
				$where[] = "`{$param}`='{$value}'";
			}
			
			$where = implode(' AND ', $where);
			$query = full_query("SELECT * FROM `{$table}` WHERE 1=1 AND {$where} ORDER BY {$order} ASC");
			
			while ($row = mysql_fetch_assoc($query)) {
				
				if ($table == 'tbldomains') {
					$response[] = array(
						'name' => $row['domain'],
						'serviceid' => '',
					);
				} else {
					$response[] = array(
						'name' => $row['name'],
						'serviceid' => $row['serviceid'],
					);
				}
			}
		}
		
		return $response;
	}
	
	public function insert ($table, $tbl_params=array()) {
		$response = array();
	
		if ($this->version >= 6) {
			$response = Capsule::connection()->transaction(
				function ($connectionManager) use ($table, $tbl_params) {
					$connectionManager->table($table)->insert($tbl_params);
				}
			);
		// versions below 6 use currently depricated query builders
		} else {
			if (!insert_query($table, $tbl_params)) {
				return false;
			}
		}
		return true;
	}
	
	public function delete ($table, $tbl_params=array()) {
		$response = array();
		
		if ($this->version >= 6) {
			$response = Capsule::connection()->transaction(
				function ($connectionManager) use ($table, $tbl_params) {
					$connectionManager->table($table)
						->where('serviceid', '=', $tbl_params['serviceid'])
						->where('name', '=', $tbl_params['name'])
						->delete();
				}
			);
		// versions below 6 use currently depricated query builders
		} else {
			$where = array();
			foreach ($tbl_params as $param=>$value) {
				$where[] = "`{$param}`='{$value}'";
			}
			
			$where = implode(' AND ', $where);
			
			if (!full_query("DELETE FROM `{$table}` WHERE {$where}")) {
				return false;
			}
		}
		return true;
	}
	
	
	public function count ($table, $tbl_params=array()) {
		$response = 0;
		if ($this->version >= 6) {
			$query = Capsule::table($table);
			foreach ($tbl_params as $column=>$value) {
				$query->where($column, $value);
			}
			
			
			$response = $query->count();
			
		// versions below 6 use currently depricated query builders
		} else {
			$where = array();
			foreach ($tbl_params as $param=>$value) {
				$where[] = "`{$param}`='{$value}'";
			}
			
			$where = implode(' AND ', $where);
			$query = full_query("SELECT COUNT(*) as `count` FROM `{$table}` WHERE 1=1 AND {$where}");
		
			$count = mysql_fetch_assoc($query);
			$response = $count['count'];
		}
		
		return $response;
	}
}

